# java-bouncycastle

The Bouncy Castle Crypto APIs for Java consist of the following:

* A lightweight cryptography API.
* A provider for the Java Cryptography Extension and the Java Cryptography Architecture.
* A clean room implementation of the JCE 1.2.1.
* A library for reading and writing encoded ASN.1 objects.
* A lightweight client-side TLS API.
* Generators for Version 1 and Version 3 X.509 certificates, Version 2 CRLs, and PKCS12 files.
* Generators for Version 2 X.509 attribute certificates.
* Generators/Processors for S/MIME and CMS (PKCS7/RFC 3852).
* Generators/Processors for OCSP (RFC 2560).
* Generators/Processors for TSP (RFC 3161).
* Generators/Processors for OpenPGP (RFC 2440).
* A signed jar version suitable for JDK 1.4-1.6 and the Sun JCE.

The lightweight API works with everything from the J2ME to the JDK 1.6.

